ITEM=5.10.2
ITEMNAME=SCREENLOCK
WINDOWMANAGER=KDE
SCREENSAVERGROUP=ScreenSaver
KDESKTOPRC=kdesktoprc
Enabled_Value=true
Lock_Value=true
LockGrace_Value=20000 	# 20 seconds
if [ -s /usr/share/applnk/System/ScreenSavers/KBlankscreen.desktop ] ; then 
    Saver_Value="KBlankscreen.desktop"
else
    if [ -s /usr/share/applnk/System/ScreenSavers/KRandom.desktop ] ; then 
       Saver_Value="KRandom.desktop"
    else
       Saver_Value="NONE"
    fi
fi
Timeout_Value=900   	# 15 minutes
#DPMS-dependent_Value=true

function GetDefaultItemValue
{
   item=$1
   case "$item" in

      Enabled)
        Item_Value=$Enabled_Value	
	return 0
	;;

      Lock)
        Item_Value=$Lock_Value	
	return 0
	;;

      LockGrace)
	Item_Value=$LockGrace_Value
	return 0
	;;

      Timeout)
	Item_Value=$Timeout_Value
	return 0
	;;

      Saver)
        Item_Value=$Saver_Value
	return 0
        ;;

   esac
}

function CompareItemValue
{
#The first 3 are string tests.  The last 2 are numeric
   local value
   local result 
   item=$1
   GetDefaultItemValue $item 
   value=$Item_Value
   result=`/usr/bin/kreadconfig --file $CONFIGDIR/$KDESKTOPRC --group $SCREENSAVERGROUP -key $item `

   case "$item" in

      Enabled | Lock | Saver)
         if [ ${result} = ${value} ] ; then	
            Compare_result="ok"
         else
            Compare_result=$value
         fi
	;;

      LockGrace | Timeout)
#We first need to check that the existing result was numeric
#If it is not numeric then we say it is not valid as it should be numeric
          if [ "`echo $result | egrep ^[[:digit:]]+$`" = "" ]; then
	      # Not a integer
              Compare_result=$value
          else
	      # Integer
              if [ ${result} -le ${value} ] ; then	
            	   Compare_result="ok"
              else
            	   Compare_result=$value
              fi
	  fi
   esac
}
if [ -s /usr/share/xsessions/kde.desktop -o -s /etc/X11/gdm/Sessions/KDE ] ; then
 if [ -x /usr/bin/kde-config ] ; then
   KDECONFIGDIRS=`/usr/bin/kde-config -path config | sed 's/:/ /' ` 
 fi
 if [ -x /usr/bin/kreadconfig ] ; then
   for CONFIGDIR in $KDECONFIGDIRS
   do
     if [ -s $CONFIGDIR/$KDESKTOPRC ] ; then
        for item in Enabled Lock LockGrace Timeout Saver
        do
          result=""
	  GetDefaultItemValue $item 
          if [  -z $Item_Value ] ; then
		# case where the key $item is not defined,  so we need to add
                 result=NOTCONFIGURED
                 /usr/bin/kwriteconfig --file $CONFIGDIR/$KDESKTOPRC --group $SCREENSAVERGROUP -key $item $Item_Value
#                 echo "$ITEM:$ITEMNAME:$WINDOWMANAGER:$item:$CONFIGDIR$KDESKTOPRC:$result:added:$Item_Value"
          else 
                 # case where we got the already defined value of $item key
                 # need to check it against what we expect
	         CompareItemValue $item 
                 if [ $Compare_result != "ok" ] ; then
                    /usr/bin/kwriteconfig --file $CONFIGDIR/$KDESKTOPRC --group $SCREENSAVERGROUP -key $item $Compare_result
#                    echo "$ITEM:$ITEMNAME:$WINDOWMANAGER:$item:$CONFIGDIR$KDESKTOPRC:$result:modified:$Compare_result"
                 else
                    # it is as we expect so leave it alone
#                    echo "$ITEM:$ITEMNAME:$WINDOWMANAGER:$item:$CONFIGDIR$KDESKTOPRC:$result:ok:$Compare_result:$Item_Value"
		     continue
                 fi
          fi
        done 
     else
#        echo "$ITEM:$ITEMNAME:$WINDOWMANAGER:$CONFIGDIR$KDESKTOPRC:FILENOTFOUND"
         continue
     fi
   done
 fi
else
# echo  "$ITEM:$ITEMNAME:$WINDOWMANAGER:NOTINSTALLED"
continue
fi
